function BJMain(){}

BJMain.prototype.initialize = function(){
	
	//VARIABLES
	window.blink = "none";
	window.blinkOn = false;
	window.autoBlink = false;
	window.maxRange = 30;
	
    window.cruiseSpeed = 0;
	window.cruiseEnabled = false;
    window.speedMs = 0;
	
	//DRAWING
    this.contentContainer = $('<div></div>').appendTo(this.rootElement);
	$('<b class="one">Engine Buttons</b>').appendTo(this.rootElement);
    $('<button>Start/Stop Engine</button>').appendTo(this.rootElement).click(function(){
        beamng.sendActiveObjectLua("drivetrain.toggleEngine()");
    });
    $('<button>Repair Engine</button>').appendTo(this.rootElement).click(function(){
        beamng.sendActiveObjectLua("drivetrain.repairEngine()");
    });
    $('<button>Repair Driveshaft</button>').appendTo(this.rootElement).click(function(){
        beamng.sendActiveObjectLua("drivetrain.enableDriveshaft()");
    });
    $('<hr><b class="one">Cruise Control</b><br><input type = "text" id = "setCruiseSpeed" value="0" size="3" maxlength="3">').appendTo(this.rootElement).click(function(){
        //beamng.sendActiveObjectLua("drivetrain.enableDriveshaft()");
    });
    $('<button>Set</button>').appendTo(this.rootElement).click(function(){
		window.cruiseSpeed = document.getElementById("setCruiseSpeed").value;
    });
    $('<button>ON/OFF</button>').appendTo(this.rootElement).click(function(){
		window.cruiseEnabled ^= true;
    });
	window.finals = {
		autoBlink: "OFF",
	};
	$('<hr><b class="one">Auto Blinkers</b>').appendTo(this.rootElement);
	$('<button onclick = "window.autoBlink ^= true;">Toggle Auto Blinkers</button>').appendTo(this.rootElement);
	$('<input size = "8" maxlength="8" id = "inputRange">').appendTo(this.rootElement);
    $('<button id = "setRange">Set Range</button>').appendTo(this.rootElement).click(function() {
	window.maxRange = document.getElementById("inputRange").value;
	});
	
    $('<style>b.one {border:solid;border-color:green;}</style>').appendTo(this.rootElement);
    
};


BJMain.prototype.update = function(streams){
	var steer = streams.electrics.steering;
	var warncrash = Math.abs(streams.sensors.gx) + Math.abs(streams.sensors.gy);
		
    window.speedMs = Math.round(streams.electrics.wheelspeed*2.236);
	if(window.cruiseEnabled) {
		var maxThrottle = (window.cruiseSpeed - speedMs)/5;
		var maxBrake = (speedMs - window.cruiseSpeed)/5;
		beamng.sendActiveObjectLua("input.event('axisy0', "+maxThrottle+", 2)");
		beamng.sendActiveObjectLua("input.event('axisy1', "+maxBrake+", 2)");
	}
	var str = '<b class="one">Main Application</b><hr>';
	this.contentContainer.html(str);
	
	if(window.autoBlink) {
		window.finals.autoBlink = "ON";
	} else {
		window.finals.autoBlink = "OFF";
	}
	
	if(window.cruiseEnabled) {
		window.finals.cruiseControlState = "ON";
	} else {
		window.finals.cruiseControlState = "OFF";
	}
	//WARN CRASH 
	{
	if(streams.engineInfo[16] === false) {
		window.finals.engineState = "ON";
	} else {
		window.finals.engineState = "OFF";
	}
	
	
	if(steer > window.maxRange) {
		window.blink = "left";
	} else if(steer < -window.maxRange) {
		window.blink = "right";
	}
	if(window.autoBlink) {
	if(window.blink == "left" && window.blinkOn == false) {
		beamng.sendActiveObjectLua("electrics.toggle_left_signal()");
		window.blinkOn = true;
	}
	if(window.blink == "right" && window.blinkOn == false) {
		beamng.sendActiveObjectLua("electrics.toggle_right_signal()");
		window.blinkOn = true;
	}
	if(window.blink == "left" && steer == 0) {
		beamng.sendActiveObjectLua("electrics.toggle_left_signal()");
		window.blinkOn = false;
		window.blink = "off";
	}
	if(window.blink == "right" && steer == 0) {
		beamng.sendActiveObjectLua("electrics.toggle_right_signal()");
		window.blinkOn = false;
		window.blink = "off";
	}
	}

    if (warncrash > 260) {
		beamng.sendActiveObjectLua("electrics.toggle_warn_signal()");
		beamng.sendActiveObjectLua("drivetrain.stopEngine()");
		beamng.sendActiveObjectLua("drivetrain.canStart = false");
    }
	}
	//END WARN CRASH 
	
	//MISC
	//END MISC
};
